﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Collections.ObjectModel;
using System.ComponentModel;
using UmlControlLibrary;

namespace UmlControlLibrary
{
    public class UmlEnumeration : DiagramElement
    {
        public UmlEnumeration(string enumerationName)
            : base(enumerationName)
        {
            LiteralList = new ObservableCollection<UmlEnumerationLiteral>();
            LiteralList.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(LiteralList_CollectionChanged);
            Metadata.Add("AllowUmlTreeviewDnd", true);
            this.Stereotype = "Enumeration";
        }


        public ObservableCollection<UmlEnumerationLiteral> LiteralList
        {
            get;
            set;
        }

        public List<Object> LiteralListView
        {
            get
            {
                if ((this.Metadata.Get<bool>("DeferredLoading")) && (!this.Metadata.Get<bool>("DeferredLoadingComplete")))
                {
//                    DeferredLoadProperties();
                }
                return LiteralList.Cast<Object>().ToList();//PropertyGroupingHelper.Group(LiteralList.Cast<UmlMemberElement>());
            }
        }

        void LiteralList_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            foreach (UmlEnumerationLiteral p in (sender as IEnumerable<UmlEnumerationLiteral>))
            {
                p.PropertyChanged -= new PropertyChangedEventHandler(LiteralListChanged);
                p.PropertyChanged += new PropertyChangedEventHandler(LiteralListChanged);
            }
            OnPropertyChanged("LiteralListView");
            OnPropertyChanged("Childs");
        }

        void LiteralListChanged(object sender, PropertyChangedEventArgs e)
        {
            OnPropertyChanged("LiteralListView");
            OnPropertyChanged("Childs");
        }

        protected override ControlTemplate GetTemplate()
        {
            return DiagramElement.DiagramElementTemplateFactory(typeof(UmlEnumerationControl));
        }

        public override ObservableCollection<UmlElement> GetChilds()
        {
            ObservableCollection<UmlElement> elements = base.GetChilds();
            foreach (UmlEnumerationLiteral literal in LiteralList)
                elements.Add(literal);
            return elements;
        }
    }
}
