﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using UmlControlLibrary;

namespace UmlControlLibrary
{
    /// <summary>
    /// Interaction logic for UmlInterfaceControl.xaml
    /// </summary>
    public partial class UmlStructControl : UmlDesignerElement
    {
        public static void RegisterControl()
        {
            SpecificMenu menu = SpecificMenu.GetTypeMenu(typeof(UmlDiagramControl));
            menu.AddItem(new SpecificMenuItem("Add struct", "Add", AddStruct));
        }

        public UmlStructControl()
            : base()
        {           
            InitializeComponent();
            SetGradientStart("#FFEBFFFC"); // bleu ciel
            SetGradientEnd("#FFAFFFF3");
        }

        public override void AddSections()
        {
            base.AddSections();
            AddSection("Members", "Members", "MemberListView", null);
        }

        public static void AddStruct(object sender, RoutedEventArgs e)
        {
            ContextMenuEventArgs args = ((sender as Control).Tag as UmlContextMenu).MenuEventArgs;
            UmlDiagramControl diagram = (sender as MenuItem).DataContext as UmlDiagramControl;
            UmlStruct _struct = new UmlStruct("New_Struct");
            diagram.InsertionPos = new Point(args.CursorLeft, args.CursorTop);
            UmlModel.CurrentDiagram.AddElement(_struct);
        
        }

    }
}
